-- museum.lua: On-Foot Audio Player [nclok1405]
-- SR2 district script
-- 3/28/07

OFAP_RADIO = {
	{
		name = "OFF",
		music = {}
	},
	{
		name = "Mixtape",
		music = {
			-- Place your favorite music here...
			"MUS_SAINTS_CLUB_1",
		}
	},
	{
		name = "89.0 Generation X",
		music = {
			"890gen_A_Deftones",					-- Deftones - Hole In The Earth
			"890GEN_A_Galactic",					-- Galactic F. Lyrics Born - I Got It
			"890gen_A_HotHotHeat",					-- Hot Hot Heat - Let Me In
			"890GEN_A_Jet",							-- Jet - Put Your Money Where Your Mouth Is
			"890gen_B_MyChemicalRomance",			-- My Chemical Romance - Teenagers
			"890gen_B_PanicAtTheDisco",				-- Panic! At The Disco - Lying Is The Most Fun
			"890gen_B_Paramore",					-- Paramore - Misery Business
			"890gen_B_PlainWhiteTs",				-- Plain White T's - Hate
			"890gen_B_RedJumpsuitApparatus",		-- Red Jumpsuit Apparatus - Face Down
			"890gen_C_TakingBackSunday",			-- Taking Back Sunday - MakeDamnSure
			"890gen_C_TheLifeAndTimes",				-- The LIfe And Times - Coat Of Arms
			"890gen_C_TheSubways",					-- The Subways - Rock And Roll Queen
			"890gen_C_TheUsed",						-- The Used - All That I've Got
			"890gen_C_MinusTheBear",				-- Minus The Bear - Knights
		}
	},
	{
		name = "95.4 KRhyme FM",
		music = {
			"954krh_A_Amerie",
			"954krh_A_Apache",
			"954krh_A_BeanieSigel",
			"954krh_A_BigPunisher",
			"954krh_B_Cassie",
			"954krh_B_ChrisetteMichelle",
			"954krh_B_DJQuik",
			"954krh_B_JossStone",
			"954krh_B_Kelis",
			"954krh_C_LloydBanks",
			"954krh_C_Nas",
			"954krh_C_NeYo",
			"954krh_C_RunDMC",
			"954krh_C_Wale",
			"954krh_C_YoungJeezy",
		}
	},
	{
		name = "Zombie Uprising",
		music = {
			"Zombie",								-- Zombie Uprising
		}
	},
}

OFAP_PC_BTN_RADIO_PREV = 29
OFAP_PC_BTN_RADIO_NEXT = 30
OFAP_PC_BTN_HORN = 26

Ofap_station = 1
Ofap_positions = {}
Ofap_audio_handle = 0

function museum_init()
end

function museum_main()
	-- This function is started while the game is still being loaded.
	-- Wait until the player(s) are ready to respond.
	while (not character_is_ready(LOCAL_PLAYER)) do
		thread_yield()
	end
	if coop_is_active() then
		while (not character_is_ready(REMOTE_PLAYER)) do
			thread_yield()
		end
	end

	while true do
		-- If a cutscene is active, wait until it's over
		while not cutscene_play_check_done() do
			thread_yield()
		end

		-- Turn off the car radio
		local myride = get_char_vehicle_name(LOCAL_PLAYER)
		if myride ~= "" then
			if radio_get_station(myride) ~= 15 then
				radio_set_station(myride, 15)
			end
			vehicle_set_radio_controls_locked(myride, true)
		end
		
		-- Detect the Station Change buttons
		local station_change = 0
		if player_button_just_pressed(OFAP_PC_BTN_RADIO_PREV) then
			station_change = -1
		elseif player_button_just_pressed(OFAP_PC_BTN_RADIO_NEXT) then
			station_change = 1
		end
		
		-- Switch the station
		if station_change ~= 0 then
			Ofap_station = Ofap_station + station_change
			if Ofap_station < 1 then
				Ofap_station = sizeof_table(OFAP_RADIO)
			end
			if Ofap_station > sizeof_table(OFAP_RADIO) then
				Ofap_station = 1
			end

			if Ofap_station == 1 then
				audio_play("SFX_RADIO_ONOFF_C")
			else
				audio_play("SFX_RADIO_DIAL_C")
			end

			mission_help_clear(SYNC_LOCAL)
			mission_help_table_nag("{PREV_RADIO_IMG} "..OFAP_RADIO[Ofap_station].name.." {NEXT_RADIO_IMG}", "", "", SYNC_LOCAL)
			
			audio_stop(Ofap_audio_handle)
			Ofap_audio_handle = 0
		end

		local current_station = OFAP_RADIO[Ofap_station]
		
		-- If no music is playing now, start a new one
		if (Ofap_audio_handle <= 0) or (not audio_is_playing(Ofap_audio_handle)) then
			if sizeof_table(current_station.music) > 0 then
				if (Ofap_positions[Ofap_station] == nil) or (Ofap_positions[Ofap_station] > sizeof_table(current_station.music)) then
					Ofap_positions[Ofap_station] = 1
				end
				
				Ofap_audio_handle = audio_play(current_station.music[Ofap_positions[Ofap_station]], "music")
				--mission_help_table_nag("Now Playing:"..current_station.music[Ofap_positions[Ofap_station]], "", "", SYNC_LOCAL)
				
				Ofap_positions[Ofap_station] = Ofap_positions[Ofap_station] + 1
			end
		end
		
		if (not character_is_in_vehicle(LOCAL_PLAYER)) and player_button_just_pressed(OFAP_PC_BTN_HORN) then
			-- Skip to the next music
			if sizeof_table(current_station.music) > 0 then
				audio_play("SFX_RADIO_DIAL_C")
				audio_stop(Ofap_audio_handle)
				Ofap_audio_handle = 0
			end
		end
		
		thread_yield()
	end
end
